Package com.google.protobuf

# Class DescriptorProtos.DescriptorProto

java.lang.Object
com.google.protobuf.AbstractMessageLite
com.google.protobuf.AbstractMessage
com.google.protobuf.GeneratedMessage
com.google.protobuf.DescriptorProtos.DescriptorProto

All Implemented Interfaces:
  `DescriptorProtos.DescriptorProtoOrBuilder`, `Message`, `MessageLite`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `Serializable`

Enclosing class:
  `DescriptorProtos`

public static final class DescriptorProtos.DescriptorProto extends GeneratedMessage implements DescriptorProtos.DescriptorProtoOrBuilder
Protobuf type `google.protobuf.DescriptorProto`

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static final class`
`DescriptorProtos.DescriptorProto.Builder`
Protobuf type `google.protobuf.DescriptorProto`
`static final class`
`DescriptorProtos.DescriptorProto.ExtensionRange`
Protobuf type `google.protobuf.DescriptorProto.ExtensionRange`
`static interface`
`DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder`
`static final class`
`DescriptorProtos.DescriptorProto.ReservedRange`
Protobuf type `google.protobuf.DescriptorProto.ReservedRange`
`static interface`
`DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder`

## Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessage

`GeneratedMessage.ExtendableBuilder<MessageT extends GeneratedMessage.ExtendableMessage<MessageT>,BuilderT extends GeneratedMessage.ExtendableBuilder<MessageT,BuilderT>>, GeneratedMessage.ExtendableMessage<MessageT extends GeneratedMessage.ExtendableMessage<MessageT>>, GeneratedMessage.ExtendableMessageOrBuilder<MessageT extends GeneratedMessage.ExtendableMessage<MessageT>>, GeneratedMessage.FieldAccessorTable, GeneratedMessage.GeneratedExtension<ContainingT extends Message,T>, GeneratedMessage.UnusedPrivateParameter`

## Nested classes/interfaces inherited from class com.google.protobuf.AbstractMessage

`AbstractMessage.BuilderParent`

## Nested classes/interfaces inherited from class com.google.protobuf.AbstractMessageLite

`AbstractMessageLite.InternalOneOfEnum`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`ENUM_TYPE_FIELD_NUMBER`
`static final int`
`EXTENSION_FIELD_NUMBER`
`static final int`
`EXTENSION_RANGE_FIELD_NUMBER`
`static final int`
`FIELD_FIELD_NUMBER`
`static final int`
`NAME_FIELD_NUMBER`
`static final int`
`NESTED_TYPE_FIELD_NUMBER`
`static final int`
`ONEOF_DECL_FIELD_NUMBER`
`static final int`
`OPTIONS_FIELD_NUMBER`
`static final int`
`RESERVED_NAME_FIELD_NUMBER`
`static final int`
`RESERVED_RANGE_FIELD_NUMBER`

### Fields inherited from class com.google.protobuf.GeneratedMessage

`alwaysUseFieldBuilders, unknownFields`

### Fields inherited from class com.google.protobuf.AbstractMessage

`memoizedSize`

### Fields inherited from class com.google.protobuf.AbstractMessageLite

`memoizedHashCode`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Compares the specified object with this message for equality.
`static DescriptorProtos.DescriptorProto`
`getDefaultInstance()`
`DescriptorProtos.DescriptorProto`
`getDefaultInstanceForType()`
Get an instance of the type with no fields set.
`static final Descriptors.Descriptor`
`getDescriptor()`
`DescriptorProtos.EnumDescriptorProto`
`getEnumType(int index)`
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`
`int`
`getEnumTypeCount()`
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`
`List<DescriptorProtos.EnumDescriptorProto>`
`getEnumTypeList()`
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`
`DescriptorProtos.EnumDescriptorProtoOrBuilder`
`getEnumTypeOrBuilder(int index)`
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`
`List<? extends DescriptorProtos.EnumDescriptorProtoOrBuilder>`
`getEnumTypeOrBuilderList()`
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`
`DescriptorProtos.FieldDescriptorProto`
`getExtension(int index)`
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`
`int`
`getExtensionCount()`
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`
`List<DescriptorProtos.FieldDescriptorProto>`
`getExtensionList()`
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`
`DescriptorProtos.FieldDescriptorProtoOrBuilder`
`getExtensionOrBuilder(int index)`
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`
`List<? extends DescriptorProtos.FieldDescriptorProtoOrBuilder>`
`getExtensionOrBuilderList()`
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`
`DescriptorProtos.DescriptorProto.ExtensionRange`
`getExtensionRange(int index)`
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`
`int`
`getExtensionRangeCount()`
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`
`List<DescriptorProtos.DescriptorProto.ExtensionRange>`
`getExtensionRangeList()`
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`
`DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder`
`getExtensionRangeOrBuilder(int index)`
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`
`List<? extends DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder>`
`getExtensionRangeOrBuilderList()`
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`
`DescriptorProtos.FieldDescriptorProto`
`getField(int index)`
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`
`int`
`getFieldCount()`
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`
`List<DescriptorProtos.FieldDescriptorProto>`
`getFieldList()`
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`
`DescriptorProtos.FieldDescriptorProtoOrBuilder`
`getFieldOrBuilder(int index)`
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`
`List<? extends DescriptorProtos.FieldDescriptorProtoOrBuilder>`
`getFieldOrBuilderList()`
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`
`String`
`getName()`
`optional string name = 1 [json_name = "name"];`
`ByteString`
`getNameBytes()`
`optional string name = 1 [json_name = "name"];`
`DescriptorProtos.DescriptorProto`
`getNestedType(int index)`
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`
`int`
`getNestedTypeCount()`
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`
`List<DescriptorProtos.DescriptorProto>`
`getNestedTypeList()`
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`
`DescriptorProtos.DescriptorProtoOrBuilder`
`getNestedTypeOrBuilder(int index)`
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`
`List<? extends DescriptorProtos.DescriptorProtoOrBuilder>`
`getNestedTypeOrBuilderList()`
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`
`DescriptorProtos.OneofDescriptorProto`
`getOneofDecl(int index)`
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`
`int`
`getOneofDeclCount()`
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`
`List<DescriptorProtos.OneofDescriptorProto>`
`getOneofDeclList()`
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`
`DescriptorProtos.OneofDescriptorProtoOrBuilder`
`getOneofDeclOrBuilder(int index)`
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`
`List<? extends DescriptorProtos.OneofDescriptorProtoOrBuilder>`
`getOneofDeclOrBuilderList()`
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`
`DescriptorProtos.MessageOptions`
`getOptions()`
`optional .google.protobuf.MessageOptions options = 7 [json_name = "options"];`
`DescriptorProtos.MessageOptionsOrBuilder`
`getOptionsOrBuilder()`
`optional .google.protobuf.MessageOptions options = 7 [json_name = "options"];`
`Parser<DescriptorProtos.DescriptorProto>`
`getParserForType()`
TODO: Remove this unnecessary intermediate implementation of this method.
`String`
`getReservedName(int index)`
`repeated string reserved_name = 10 [json_name = "reservedName"];`
`ByteString`
`getReservedNameBytes(int index)`
`repeated string reserved_name = 10 [json_name = "reservedName"];`
`int`
`getReservedNameCount()`
`repeated string reserved_name = 10 [json_name = "reservedName"];`
`ProtocolStringList`
`getReservedNameList()`
`repeated string reserved_name = 10 [json_name = "reservedName"];`
`DescriptorProtos.DescriptorProto.ReservedRange`
`getReservedRange(int index)`
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`
`int`
`getReservedRangeCount()`
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`
`List<DescriptorProtos.DescriptorProto.ReservedRange>`
`getReservedRangeList()`
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`
`DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder`
`getReservedRangeOrBuilder(int index)`
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`
`List<? extends DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder>`
`getReservedRangeOrBuilderList()`
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`
`int`
`getSerializedSize()`
Get the number of bytes required to encode this message.
`int`
`hashCode()`
Returns the hash code value for this message.
`boolean`
`hasName()`
`optional string name = 1 [json_name = "name"];`
`boolean`
`hasOptions()`
`optional .google.protobuf.MessageOptions options = 7 [json_name = "options"];`
`protected GeneratedMessage.FieldAccessorTable`
`internalGetFieldAccessorTable()`
Get the FieldAccessorTable for this type.
`final boolean`
`isInitialized()`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`static DescriptorProtos.DescriptorProto.Builder`
`newBuilder()`
`static DescriptorProtos.DescriptorProto.Builder`
`newBuilder(DescriptorProtos.DescriptorProto prototype)`
`DescriptorProtos.DescriptorProto.Builder`
`newBuilderForType()`
Constructs a new builder for a message of the same type as this message.
`protected DescriptorProtos.DescriptorProto.Builder`
`newBuilderForType(AbstractMessage.BuilderParent parent)`
Create a nested builder.
`static DescriptorProtos.DescriptorProto`
`parseDelimitedFrom(InputStream input)`
`static DescriptorProtos.DescriptorProto`
`parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(byte[] data)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(ByteString data)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(CodedInputStream input)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(InputStream input)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(ByteBuffer data)`
`static DescriptorProtos.DescriptorProto`
`parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry)`
`static Parser<DescriptorProtos.DescriptorProto>`
`parser()`
`DescriptorProtos.DescriptorProto.Builder`
`toBuilder()`
Constructs a builder initialized with the current message.
`void`
`writeTo(CodedOutputStream output)`
Serializes the message and writes it to `output`.

### Methods inherited from class com.google.protobuf.GeneratedMessage

`canUseUnsafe, computeStringSize, computeStringSizeNoTag, emptyBooleanList, emptyDoubleList, emptyFloatList, emptyIntList, emptyList, emptyLongList, getAllFields, getDescriptorForType, getField, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof, internalGetMapField, internalGetMapFieldReflection, isStringEmpty, makeMutableCopy, makeMutableCopy, mergeFromAndMakeImmutableInternal, newFileScopedGeneratedExtension, newInstance, newMessageScopedGeneratedExtension, parseDelimitedWithIOException, parseDelimitedWithIOException, parseUnknownField, parseUnknownFieldProto3, parseWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, serializeBooleanMapTo, serializeIntegerMapTo, serializeLongMapTo, serializeStringMapTo, writeReplace, writeString, writeStringNoTag`

### Methods inherited from class com.google.protobuf.AbstractMessage

`findInitializationErrors, getInitializationErrorString, hashFields, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite

`addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.MessageLite

`toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

## Field Details

### NAME_FIELD_NUMBER

public static final int NAME_FIELD_NUMBER

See Also:
  - Constant Field Values

### FIELD_FIELD_NUMBER

public static final int FIELD_FIELD_NUMBER

See Also:
  - Constant Field Values

### EXTENSION_FIELD_NUMBER

public static final int EXTENSION_FIELD_NUMBER

See Also:
  - Constant Field Values

### NESTED_TYPE_FIELD_NUMBER

public static final int NESTED_TYPE_FIELD_NUMBER

See Also:
  - Constant Field Values

### ENUM_TYPE_FIELD_NUMBER

public static final int ENUM_TYPE_FIELD_NUMBER

See Also:
  - Constant Field Values

### EXTENSION_RANGE_FIELD_NUMBER

public static final int EXTENSION_RANGE_FIELD_NUMBER

See Also:
  - Constant Field Values

### ONEOF_DECL_FIELD_NUMBER

public static final int ONEOF_DECL_FIELD_NUMBER

See Also:
  - Constant Field Values

### OPTIONS_FIELD_NUMBER

public static final int OPTIONS_FIELD_NUMBER

See Also:
  - Constant Field Values

### RESERVED_RANGE_FIELD_NUMBER

public static final int RESERVED_RANGE_FIELD_NUMBER

See Also:
  - Constant Field Values

### RESERVED_NAME_FIELD_NUMBER

public static final int RESERVED_NAME_FIELD_NUMBER

See Also:
  - Constant Field Values

## Method Details

### getDescriptor

public static final Descriptors.Descriptor getDescriptor()

### internalGetFieldAccessorTable

protected GeneratedMessage.FieldAccessorTable internalGetFieldAccessorTable()
Description copied from class: `GeneratedMessage`
Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.

Specified by:
  `internalGetFieldAccessorTable` in class `GeneratedMessage`

### hasName

public boolean hasName()
`optional string name = 1 [json_name = "name"];`

Specified by:
  `hasName` in interface `DescriptorProtos.DescriptorProtoOrBuilder`
Returns:
  Whether the name field is set.

### getName

public String getName()
`optional string name = 1 [json_name = "name"];`

Specified by:
  `getName` in interface `DescriptorProtos.DescriptorProtoOrBuilder`
Returns:
  The name.

### getNameBytes

public ByteString getNameBytes()
`optional string name = 1 [json_name = "name"];`

Specified by:
  `getNameBytes` in interface `DescriptorProtos.DescriptorProtoOrBuilder`
Returns:
  The bytes for name.

### getFieldList

public List<DescriptorProtos.FieldDescriptorProto> getFieldList()
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`

Specified by:
  `getFieldList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getFieldOrBuilderList

public List<? extends DescriptorProtos.FieldDescriptorProtoOrBuilder> getFieldOrBuilderList()
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`

Specified by:
  `getFieldOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getFieldCount

public int getFieldCount()
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`

Specified by:
  `getFieldCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getField

public DescriptorProtos.FieldDescriptorProto getField(int index)
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`

Specified by:
  `getField` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getFieldOrBuilder

public DescriptorProtos.FieldDescriptorProtoOrBuilder getFieldOrBuilder(int index)
`repeated .google.protobuf.FieldDescriptorProto field = 2 [json_name = "field"];`

Specified by:
  `getFieldOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtensionList

public List<DescriptorProtos.FieldDescriptorProto> getExtensionList()
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`

Specified by:
  `getExtensionList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtensionOrBuilderList

public List<? extends DescriptorProtos.FieldDescriptorProtoOrBuilder> getExtensionOrBuilderList()
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`

Specified by:
  `getExtensionOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtensionCount

public int getExtensionCount()
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`

Specified by:
  `getExtensionCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtension

public DescriptorProtos.FieldDescriptorProto getExtension(int index)
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`

Specified by:
  `getExtension` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtensionOrBuilder

public DescriptorProtos.FieldDescriptorProtoOrBuilder getExtensionOrBuilder(int index)
`repeated .google.protobuf.FieldDescriptorProto extension = 6 [json_name = "extension"];`

Specified by:
  `getExtensionOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getNestedTypeList

public List<DescriptorProtos.DescriptorProto> getNestedTypeList()
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`

Specified by:
  `getNestedTypeList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getNestedTypeOrBuilderList

public List<? extends DescriptorProtos.DescriptorProtoOrBuilder> getNestedTypeOrBuilderList()
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`

Specified by:
  `getNestedTypeOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getNestedTypeCount

public int getNestedTypeCount()
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`

Specified by:
  `getNestedTypeCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getNestedType

public DescriptorProtos.DescriptorProto getNestedType(int index)
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`

Specified by:
  `getNestedType` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getNestedTypeOrBuilder

public DescriptorProtos.DescriptorProtoOrBuilder getNestedTypeOrBuilder(int index)
`repeated .google.protobuf.DescriptorProto nested_type = 3 [json_name = "nestedType"];`

Specified by:
  `getNestedTypeOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getEnumTypeList

public List<DescriptorProtos.EnumDescriptorProto> getEnumTypeList()
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`

Specified by:
  `getEnumTypeList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getEnumTypeOrBuilderList

public List<? extends DescriptorProtos.EnumDescriptorProtoOrBuilder> getEnumTypeOrBuilderList()
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`

Specified by:
  `getEnumTypeOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getEnumTypeCount

public int getEnumTypeCount()
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`

Specified by:
  `getEnumTypeCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getEnumType

public DescriptorProtos.EnumDescriptorProto getEnumType(int index)
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`

Specified by:
  `getEnumType` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getEnumTypeOrBuilder

public DescriptorProtos.EnumDescriptorProtoOrBuilder getEnumTypeOrBuilder(int index)
`repeated .google.protobuf.EnumDescriptorProto enum_type = 4 [json_name = "enumType"];`

Specified by:
  `getEnumTypeOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtensionRangeList

public List<DescriptorProtos.DescriptorProto.ExtensionRange> getExtensionRangeList()
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`

Specified by:
  `getExtensionRangeList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtensionRangeOrBuilderList

public List<? extends DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder> getExtensionRangeOrBuilderList()
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`

Specified by:
  `getExtensionRangeOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtensionRangeCount

public int getExtensionRangeCount()
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`

Specified by:
  `getExtensionRangeCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtensionRange

public DescriptorProtos.DescriptorProto.ExtensionRange getExtensionRange(int index)
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`

Specified by:
  `getExtensionRange` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getExtensionRangeOrBuilder

public DescriptorProtos.DescriptorProto.ExtensionRangeOrBuilder getExtensionRangeOrBuilder(int index)
`repeated .google.protobuf.DescriptorProto.ExtensionRange extension_range = 5 [json_name = "extensionRange"];`

Specified by:
  `getExtensionRangeOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getOneofDeclList

public List<DescriptorProtos.OneofDescriptorProto> getOneofDeclList()
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`

Specified by:
  `getOneofDeclList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getOneofDeclOrBuilderList

public List<? extends DescriptorProtos.OneofDescriptorProtoOrBuilder> getOneofDeclOrBuilderList()
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`

Specified by:
  `getOneofDeclOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getOneofDeclCount

public int getOneofDeclCount()
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`

Specified by:
  `getOneofDeclCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getOneofDecl

public DescriptorProtos.OneofDescriptorProto getOneofDecl(int index)
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`

Specified by:
  `getOneofDecl` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getOneofDeclOrBuilder

public DescriptorProtos.OneofDescriptorProtoOrBuilder getOneofDeclOrBuilder(int index)
`repeated .google.protobuf.OneofDescriptorProto oneof_decl = 8 [json_name = "oneofDecl"];`

Specified by:
  `getOneofDeclOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### hasOptions

public boolean hasOptions()
`optional .google.protobuf.MessageOptions options = 7 [json_name = "options"];`

Specified by:
  `hasOptions` in interface `DescriptorProtos.DescriptorProtoOrBuilder`
Returns:
  Whether the options field is set.

### getOptions

public DescriptorProtos.MessageOptions getOptions()
`optional .google.protobuf.MessageOptions options = 7 [json_name = "options"];`

Specified by:
  `getOptions` in interface `DescriptorProtos.DescriptorProtoOrBuilder`
Returns:
  The options.

### getOptionsOrBuilder

public DescriptorProtos.MessageOptionsOrBuilder getOptionsOrBuilder()
`optional .google.protobuf.MessageOptions options = 7 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getReservedRangeList

public List<DescriptorProtos.DescriptorProto.ReservedRange> getReservedRangeList()
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`

Specified by:
  `getReservedRangeList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getReservedRangeOrBuilderList

public List<? extends DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder> getReservedRangeOrBuilderList()
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`

Specified by:
  `getReservedRangeOrBuilderList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getReservedRangeCount

public int getReservedRangeCount()
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`

Specified by:
  `getReservedRangeCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getReservedRange

public DescriptorProtos.DescriptorProto.ReservedRange getReservedRange(int index)
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`

Specified by:
  `getReservedRange` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getReservedRangeOrBuilder

public DescriptorProtos.DescriptorProto.ReservedRangeOrBuilder getReservedRangeOrBuilder(int index)
`repeated .google.protobuf.DescriptorProto.ReservedRange reserved_range = 9 [json_name = "reservedRange"];`

Specified by:
  `getReservedRangeOrBuilder` in interface `DescriptorProtos.DescriptorProtoOrBuilder`

### getReservedNameList

public ProtocolStringList getReservedNameList()
`repeated string reserved_name = 10 [json_name = "reservedName"];`

Specified by:
  `getReservedNameList` in interface `DescriptorProtos.DescriptorProtoOrBuilder`
Returns:
  A list containing the reservedName.

### getReservedNameCount

public int getReservedNameCount()
`repeated string reserved_name = 10 [json_name = "reservedName"];`

Specified by:
  `getReservedNameCount` in interface `DescriptorProtos.DescriptorProtoOrBuilder`
Returns:
  The count of reservedName.

### getReservedName

public String getReservedName(int index)
`repeated string reserved_name = 10 [json_name = "reservedName"];`

Specified by:
  `getReservedName` in interface `DescriptorProtos.DescriptorProtoOrBuilder`
Parameters:
  `index` - The index of the element to return.
Returns:
  The reservedName at the given index.

### getReservedNameBytes

public ByteString getReservedNameBytes(int index)
`repeated string reserved_name = 10 [json_name = "reservedName"];`

Specified by:
  `getReservedNameBytes` in interface `DescriptorProtos.DescriptorProtoOrBuilder`
Parameters:
  `index` - The index of the value to return.
Returns:
  The bytes of the reservedName at the given index.

### isInitialized

public final boolean isInitialized()
Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

Specified by:
  `isInitialized` in interface `MessageLiteOrBuilder`
Overrides:
  `isInitialized` in class `GeneratedMessage`

### writeTo

public void writeTo(CodedOutputStream output) throws IOException
Description copied from interface: `MessageLite`
Serializes the message and writes it to `output`. This does not flush or close the stream.

Specified by:
  `writeTo` in interface `MessageLite`
Overrides:
  `writeTo` in class `GeneratedMessage`
Throws:
  `IOException`

### getSerializedSize

public int getSerializedSize()
Description copied from interface: `MessageLite`
Get the number of bytes required to encode this message. The result is only computed on the first call and memoized after that. If this message requires more than Integer.MAX_VALUE bytes to encode, the return value will be smaller than the actual number of bytes required and might be negative.

Specified by:
  `getSerializedSize` in interface `MessageLite`
Overrides:
  `getSerializedSize` in class `GeneratedMessage`

### equals

public boolean equals(Object obj)
Description copied from interface: `Message`
Compares the specified object with this message for equality. Returns `true` if the given object is a message of the same type (as defined by `getDescriptorForType()`) and has identical values for all of its fields. Subclasses must implement this; inheriting `Object.equals()` is incorrect.

Specified by:
  `equals` in interface `Message`
Overrides:
  `equals` in class `AbstractMessage`
Parameters:
  `obj` - object to be compared for equality with this message
Returns:
  `true` if the specified object is equal to this message

### hashCode

public int hashCode()
Description copied from interface: `Message`
Returns the hash code value for this message. The hash code of a message should mix the message's type (object identity of the descriptor) with its contents (known and unknown field values). Subclasses must implement this; inheriting `Object.hashCode()` is incorrect.

Specified by:
  `hashCode` in interface `Message`
Overrides:
  `hashCode` in class `AbstractMessage`
Returns:
  the hash code value for this message
See Also:
  - `Map.hashCode()`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(ByteBuffer data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(ByteString data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(byte[] data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(InputStream input) throws IOException

Throws:
  `IOException`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### parseDelimitedFrom

public static DescriptorProtos.DescriptorProto parseDelimitedFrom(InputStream input) throws IOException

Throws:
  `IOException`

### parseDelimitedFrom

public static DescriptorProtos.DescriptorProto parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(CodedInputStream input) throws IOException

Throws:
  `IOException`

### parseFrom

public static DescriptorProtos.DescriptorProto parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### newBuilderForType

public DescriptorProtos.DescriptorProto.Builder newBuilderForType()
Description copied from interface: `MessageLite`
Constructs a new builder for a message of the same type as this message.

Specified by:
  `newBuilderForType` in interface `Message`
Specified by:
  `newBuilderForType` in interface `MessageLite`

### newBuilder

public static DescriptorProtos.DescriptorProto.Builder newBuilder()

### newBuilder

public static DescriptorProtos.DescriptorProto.Builder newBuilder(DescriptorProtos.DescriptorProto prototype)

### toBuilder

public DescriptorProtos.DescriptorProto.Builder toBuilder()
Description copied from interface: `MessageLite`
Constructs a builder initialized with the current message. Use this to derive a new message from the current one.

Specified by:
  `toBuilder` in interface `Message`
Specified by:
  `toBuilder` in interface `MessageLite`

### newBuilderForType

protected DescriptorProtos.DescriptorProto.Builder newBuilderForType(AbstractMessage.BuilderParent parent)
Description copied from class: `AbstractMessage`
Create a nested builder.

Overrides:
  `newBuilderForType` in class `AbstractMessage`

### getDefaultInstance

public static DescriptorProtos.DescriptorProto getDefaultInstance()

### parser

public static Parser<DescriptorProtos.DescriptorProto> parser()

### getParserForType

public Parser<DescriptorProtos.DescriptorProto> getParserForType()
Description copied from class: `GeneratedMessage`
TODO: Remove this unnecessary intermediate implementation of this method.

Specified by:
  `getParserForType` in interface `Message`
Specified by:
  `getParserForType` in interface `MessageLite`
Overrides:
  `getParserForType` in class `GeneratedMessage`

### getDefaultInstanceForType

public DescriptorProtos.DescriptorProto getDefaultInstanceForType()
Description copied from interface: `MessageLiteOrBuilder`
Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.

Specified by:
  `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
Specified by:
  `getDefaultInstanceForType` in interface `MessageOrBuilder`